var cdsAdded;
var tooOld;					//number of days before an album is considered 'too old', set in preferences
var curContent;
var oldContent;				//used to store the previously listed div so it can be hidden

var scrollbar, scrollArea;	//scroll objects
var gDoneButton, gInfoButton; //buttons 

var lastStatus;				//string containing the last system status displayed
var displayingToolTip;		//boolean if a mouseover tool tip is being displayed

var stretcher;
var searcher;
var prefs;
var artist_button;
var album_button;
var wish_button;
var expand_button;
var import_button;
var run_button;
var progressBar;

//precached dom elements
var artistList;
var albumList;
var wishList;

var status;
var minSize = { x : 375, y : 225 };
var VERSION = "2.1.1";
function setup() {
	
	//set up global objects
	progressBar = new ProgressBar(14, 30, 340, 0, 0, document.getElementById("progressBar"), "images/progress-empty.png", "images/progress-full.png");
	searcher = new AmazonSearcher(progressBar);
	albumHandler = new AlbumHandler();
	stretcher = new Stretcher(document.getElementById('front'), 250, 300, stretchDone);
	Artist.status = status;
	//set up the buttons
	artist_button = new ToggleButton(document.getElementById("artist-img"), showArtists, "images/artists-un.png", "images/artists-hl.png", "images/artists-sel.png", "images/artists-sel.png", document.getElementById("tab-text"), "my artists");
	album_button = new ToggleButton(document.getElementById("album-img"), showAlbums, "images/albums-un.png", "images/albums-hl.png", "images/albums-sel.png", "images/albums-sel.png", document.getElementById("tab-text"), "new albums");
	wish_button = new ToggleButton(document.getElementById("wish-img"), showWish, "images/wish-un.png", "images/wish-hl.png", "images/wish-sel.png", "images/wish-sel.png", document.getElementById("tab-text"), "my wishlist");
	expand_button = new ToggleButton(document.getElementById("opener"), expander, "images/opener.png", "images/opener-hl.png", "images/closer.png", "images/closer-hl.png");
	expand_button.setToggleOnClick(false);
	
	run_button = new ToggleButton(document.getElementById("run-img"), run, "images/run-un.png", "images/run-hl.png", "images/run-sel.png", "images/run-sel-hl.png", document.getElementById("tab-text"), "start search", "pause");
	stop_button = new SimpleButton(document.getElementById("stop-img"), 	function(){ searcher.cancel(); }, "images/stop.png", "images/stop-hl.png",  document.getElementById("tab-text"), "cancel");
	stop_button.show(false);
	
	new SimpleButton(document.getElementById("newversion-img"), function(){ clicked("http://www.jim-george.com/newTunes/download.html") }, "images/new-version.png",  "images/new-version-hl.png", document.getElementById("tab-text"), "new version");
	
	new SimpleButton(document.getElementById("import"), loadLibrary, "images/import.png", "images/import-hl.png", document.getElementById("footer-text"), "refresh artists");
	new SimpleButton(document.getElementById("sel-all"), Artist.selectAll, "images/select-all.png",  "images/select-all-hl.png", document.getElementById("footer-text"), "select all");
	new SimpleButton(document.getElementById("sel-none"), Artist.deselectAll, "images/select-none.png",  "images/select-none-hl.png", document.getElementById("footer-text"), "deselect all");

	new SimpleButton(document.getElementById("sort-az"), albumHandler.sortAlpha, "images/sort-alpha.png", "images/sort-alpha-hl.png", document.getElementById("footer-text"), "sort by artist");
	new SimpleButton(document.getElementById("sort-date"), albumHandler.sortDate, "images/sort-date.png", "images/sort-date-hl.png", document.getElementById("footer-text"), "sort by release date");
	new SimpleButton(document.getElementById("clear-all"), albumHandler.clearAll, "images/clear-all.png", "images/clear-all-hl.png", document.getElementById("footer-text"), "clear album list");

	//set up the info and back buttons
	new AppleGlassButton(document.getElementById("excludedButton"), "Excluded Albums", showExcluded);
	new AppleGlassButton(document.getElementById('checkForUpdate'), "Check for Updates", checkVersion);
	new AppleGlassButton(document.getElementById("doneButton"), "Done", PreferenceHandler.hidePrefs);
	new AppleGlassButton(document.getElementById("backButton"), "Back", function(){ document.getElementById("options").style.display = "block"; document.getElementById("excluded").style.display = "none";});
	new AppleGlassButton(document.getElementById("removeExcluded"), "Remove", function(){ albumHandler.killList.deleteSelected(); });
	new AppleGlassButton(document.getElementById("clearExcluded"), "Clear", function(){ albumHandler.killList.clear(); });
	new AppleGlassButton(document.getElementById("donate"), "Donate", donate);

	new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", PreferenceHandler.showPrefs);
		
	//set up the scroll bar
	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	scrollArea = new AppleScrollArea(document.getElementById("scrollArea"), scrollbar);
	scrollbar.setScrollArea(scrollArea);
	
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 25;
	scrollArea.focus(); // for key control when first loading
	
	window.onfocus = function () { scrollArea.focus(); }
	window.onblur = function () { scrollArea.blur(); }
	
	artistList = document.getElementById("artistList");
 	albumList = document.getElementById("albumList");
 	wishList = document.getElementById("wishList");
	
	document.getElementById("version").innerText = "v" + VERSION;
	if(window.widget){
		widget.onshow = onshow;
		widget.onhide = onhide;
		widget.onremove = removalHandler;
	}
	curContent = artistList;
	PreferenceHandler.loadPrefs();
}

//---------------------------------------------------------------------
// display changer to handle swapping to the artist list
//---------------------------------------------------------------------
function showArtists(show) {
	if(show){
		album_button.deselect();
		wish_button.deselect();
		displayContent(artistList);
	}
	//if we want to hide it or if the stretcher is not opened, call stretch.
	if(!show || !stretcher.isStretched()){
		 stretcher.stretch();
	}
	
	document.getElementById("favorite-buttons").style.display = "none";
	document.getElementById("artist-buttons").style.display = "block";
	document.getElementById("album-buttons").style.display = "none";
	
	curContent = artistList;
}

function showAlbums(show) {
	if(show){
		artist_button.deselect();
		wish_button.deselect();
		displayContent(albumList);
	}
	//if we want to hide it or if the stretcher is not opened, call stretch.
	if(!show || !stretcher.isStretched()){
		stretcher.stretch();
	}
	document.getElementById("favorite-buttons").style.display = "none";
	document.getElementById("artist-buttons").style.display = "none";
	document.getElementById("album-buttons").style.display = "block";
	
	curContent = albumList;
}


//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function showWish(show) {
	if(show){
		artist_button.deselect();
		album_button.deselect();
		displayContent(wishList);
	}
	//if we want to hide it or if the stretcher is not opened, call stretch.
	if(!show || !stretcher.isStretched()){
		 stretcher.stretch();
	}
	document.getElementById("favorite-buttons").style.display = "block";
	document.getElementById("artist-buttons").style.display = "none";
	document.getElementById("album-buttons").style.display = "none";

	curContent = wishList;
}

function expander(show) {
	getCurrentButton().clicked();
}

function getCurrentButton(){
	if(curContent == artistList){
		return artist_button;
	} else if(curContent == albumList){
		return album_button;
	} else if(curContent == wishList){
		return wish_button;
	}
	return null;
}
function onshow(){
	attemptAutoUpdate();
}

function onhide(){
	if(searcher.inSearch && !backgroundSearches){
		run_button.clicked();
	}
	PreferenceHandler.savePrefs();
}
/**
 * This method handles a fair amount of search logic
 * involving contrlling the searcher object.
 */
function run(){
	if(!searcher.inSearch){
		if(!stretcher.isStretched()){
			album_button.clicked();
		}
		stop_button.show(true);
		searcher.initSearch();
		Artist.query();
	}else if(searcher.paused){
		//we are in a search, and it is paused
		searcher.unpause();
	}else{
		//we are in a search and it is NOT paused
		searcher.pause();
	}
}

function displayFinished(){
	document.getElementById("tab-text").innerText = "";
	firstRun = false;
	showProgressBar(false);
	progressBar.update(0);
	stop_button.show(false);
	if(!searcher.paused){
		run_button.toggleSelected();
	}
}

 
function setAlbumCount(count){
	var albumText = count + " album" + (count != 1 ? "s" : "");
	document.getElementById('status-album').innerText = albumText;
}
 
function setArtistCount(count){
	 var artistText = count + " artist" + (count != 1 ? "s" : "");
	 document.getElementById('status-artist').innerText = artistText;
}

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function removalHandler(){
	PreferenceHandler.nullifyPreferences();
}

//---------------------------------------------------------------------------------------------
//displays a div tag, either artists or albums
//---------------------------------------------------------------------------------------------
function displayContent(newContent){
	if (oldContent != null) {
		oldContent.style.display = 'none';
	}
	newContent.style.display = 'block';
	
	scrollArea.reveal(newContent);
	
	scrollArea.refresh();
	
	oldContent = newContent;
}

//---------------------------------------------------------------------------------------------
// Returns true if the date is new enough to be considered a new release
//---------------------------------------------------------------------------------------------
function isNew(date){
	if(date == ""){
		return false;
	}
	var daysOld = (getTodayUTC() - getAlbumUTC(date))/1000/60/60/24;
	return daysOld < tooOld;
}

function getTodayUTC(){
	var today = new Date();
	return Date.UTC(today.getFullYear(), today.getMonth()+1, today.getDate());
}

function getAlbumUTC(date){
	var yearMonthDay = date.split("-");
	return Date.UTC(yearMonthDay[0], yearMonthDay[1], yearMonthDay[2])
}

//---------------------------------------------------------------------------------------------
// open an external browser with the given url
//---------------------------------------------------------------------------------------------
function clicked(url){
	if(widget)
		widget.openURL(url);
}

//---------------------------------------------------------------------------------------------
// validates text as containing only numbers
//---------------------------------------------------------------------------------------------
function isNumeric(text){
	var nums = "0123456789";
	for (i = 0; i < text.length; i++){ 
		if (nums.indexOf(text.charAt(i)) == -1){
 			return false;
		}
	}
	return true;
}

//---------------------------------------------------------------------------------------------
// return the english equivalent of a date from Amazon
//---------------------------------------------------------------------------------------------
function textDate(date){
	var yearMonthDay = date.split("-");
	var monthText;
	switch(yearMonthDay[1]){
		case "01": 
			monthText = "January"; break;
		case "02": 
			monthText = "February"; break;
		case "03": 
			monthText = "March"; break;
		case "04": 
			monthText = "April"; break;
		case "05": 
			monthText = "May"; break;
		case "06": 
			monthText = "June"; break;
		case "07": 
			monthText = "July"; break;
		case "08": 
			monthText = "August"; break;
		case "09": 
			monthText = "September"; break;
		case "10": 
			monthText = "October"; break;
		case "11": 
			monthText = "November"; break;
		default:
			monthText = "December";
	}
	return monthText + " " + yearMonthDay[2] + ", " + yearMonthDay[0];
}

function showExcluded(){
	document.getElementById("options").style.display = "none"; 
	document.getElementById("excluded").style.display = "block";
	
	albumHandler.killList.populateListbox();
}

function showProgressBar(show){
	if(show){
		document.getElementById("progressBar").style.display="block";
		document.getElementById("footer-buttons").style.display="none";
	}else{
		document.getElementById("progressBar").style.display = "none";
		document.getElementById("footer-buttons").style.display = "block";
	}
}

function deleteChildren(obj){
	while (obj.firstChild){
  		obj.removeChild(obj.firstChild);
 	}
}
function attemptAutoUpdate(){
	if(!allowUpdate){
		//alert("disallowing update");
		displayUpdateStatus();
		return;
	}
	var today = daysUTC();
	if(!whenUpdated || today - whenUpdated > 1){
		//alert("checked more than a day ago");
		checkVersion();
	}else{
		//alert("checked already today");
		displayUpdateStatus();
	}
}	

function customXMLChanged(check){
	var textInput = document.getElementById("xmlfile");
	if(check.checked == 1){
		textInput.disabled = false;
	}else{
		textInput.disabled = true;
		textInput.value = "~/Music/iTunes/iTunes Music Library.xml";
	}	
	
}

function checkVersion(){
	var url = 'http://www.jim-george.com/newTunes/version.xml';
	var xml_request = new XMLHttpRequest();
	xml_request.onload = function(e) {xml_loaded(e, xml_request);}
	xml_request.overrideMimeType("text/xml");
	xml_request.open("GET", url);
	xml_request.setRequestHeader("Cache-Control", "no-cache");
	xml_request.send(null);
}


function displayUpdateStatus(){
	if(!curVersion){
		document.getElementById("newversion-img").style.display = "none";
		document.getElementById("uptodate").innerText = "";
	}else if(curVersion == VERSION){
		document.getElementById("newversion-img").style.display = "none";
		var daysAgo = daysUTC() - whenUpdated;
		//	alert(getTodayUTC());
		if(daysAgo == 0){
			document.getElementById("uptodate").innerText = "up to date as of today";
		}else if(daysAgo == 1){
			document.getElementById("uptodate").innerText = "up to date as of yesterday"; 
		}else{
			document.getElementById("uptodate").innerText = "up to date as of " + daysAgo + " days ago"; 
		}
	}else{
		document.getElementById("newversion-img").style.display = "block";
		document.getElementById("version").innerHTML = "version " + curVersion + " available.<br/> <a href='javascript:clicked(\"http://www.jim-george.com/newTunes/download.html\")'>click here</a>";
	}
}

function xml_loaded(event, req){
	if (req.readyState == 4) {
		if (req.status == 200) {
			var response  = req.responseXML.documentElement;
 			curVersion = response.getElementsByTagName('version')[0].firstChild.data;
			if(curVersion == VERSION){
				document.getElementById("uptodate").innerText = "no updates available at this time";
				setTimeout("displayUpdateStatus();", 5000);
			}else{
				displayUpdateStatus();
			}
			whenUpdated = daysUTC();
		}
	}
}

function daysUTC(){
	return getTodayUTC()/1000/60/60/24;
}

function donate(){
	clicked("https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=backsmith%40gmail%2ecom&item_name=newTunes%20widget&no_shipping=2&no_note=1&tax=0&currency_code=USD&lc=US&bn=PP%2dDonationsBF&charset=UTF%2d8");
}